#include <dpmi.h>
#include <math.h>
#define OBJNUM 4

__dpmi_regs regs;
char p[64000];
int A[OBJNUM], B[OBJNUM], C[OBJNUM], R[OBJNUM], R2[OBJNUM], OBJ[OBJNUM],
    A1[OBJNUM], B1[OBJNUM], C1[OBJNUM],
    A2[OBJNUM], B2[OBJNUM], C2[OBJNUM],
    A3[OBJNUM], B3[OBJNUM], C3[OBJNUM],
    B32[OBJNUM],
    RAIZ[2097151], PSINXA, PCOSXA, PSINYA, PCOSYA,
    X, Y, X0, Y0, Z0, XA, YA, N, POS, AA, I,
    PA1, PB1, PC1, PA2, PB2, PC2, MV, MV2, COL, OBJMIN, TMIN,
    PSIN[16384], PCOS[16384];


int main()
{

    inicio();

    for (N=0; N<=16383; N++)
    {
        PSIN[N]=(sin((N-8192)*((3.141592)/(4096)))*65536);
        PCOS[N]=(cos((N-8192)*((3.141592)/(4096)))*65536);
    }
    for (N=0; N<=2097151; N++)
    {
        RAIZ[N]=(int)(-sqrt(N)*32);
    }

    for (I=0; I<=800; I++)
    {
    POS=0;
    OBJ[0]=0; A[0]=0; B[0]=100; C[0]=1450; R[0]=650; R2[0]=R[0]*R[0];
    OBJ[1]=0; A[1]=-600; B[1]=-450; C[1]=1450; R[1]=300; R2[1]=R[1]*R[1];
    OBJ[2]=0; A[2]=600; B[2]=-450; C[2]=1450; R[2]=300; R2[2]=R[2]*R[2];
    OBJ[3]=1; A[3]=600-I*8; B[3]=0; C[3]=0;
    for (Y=-100; Y<=99; Y++)
    {
        Y0=Y<<2;
        YA=8192+Y0;
        Z0=0;
        for (N=0; N<=(OBJNUM-1); N++)
        {
                B1[N]=B[N]-Y0;
                C1[N]=C[N]-Z0;
                B3[N]=(B1[N]*PCOS[YA]-C1[N]*PSIN[YA])>>16;
                C3[N]=(B1[N]*PSIN[YA]-C1[N]*PCOS[YA])>>16;
                B32[N]=B3[N]*B3[N];
        }
        for (X=-160; X<=159; X++)
        {
            OBJMIN=OBJNUM;
            TMIN=10000000;
            X0=X<<2;
            XA=8192+X0;
            for (N=0; N<=(OBJNUM-1); N++)
            {
                if (OBJ[N]==0 && B32[N]<=R2[N])
                {
                    A2[N]=((A[N]-X0)*PCOS[XA]+C3[N]*PSIN[XA])>>16;
                    AA=(A2[N]*A2[N]+B32[N]);
                    if (AA<R2[N])
                    {
                        C2[N]=((A[N]-X0)*PSIN[XA]+C3[N]*PCOS[XA])>>16;
                        PC1=RAIZ[(R2[N]-AA)>>10]-C2[N];
                        if (TMIN>PC1 && PC1>0)
                        {
                            TMIN=PC1;
                            OBJMIN=N;
                        }
                    }
                }
            }
            if (TMIN<10000000 && OBJ[OBJMIN]==0)
            {
                       A2[3]=((A[3]-X0)*PCOS[XA]+C3[3]*PSIN[XA])>>16;
                       C2[3]=((A[3]-X0)*PSIN[XA]+C3[3]*PCOS[XA])>>16;
                       PC1=TMIN+C2[OBJMIN];
                       PC2=C2[3]+TMIN;
                       MV2=RAIZ[(A2[3]*A2[3]+B32[3]+PC2*PC2)>>10];
                       COL=200*(PC1*PC2+A2[OBJMIN]*A2[3]+B3[OBJMIN]*B3[3])/(R[OBJMIN]*MV2);
                       if (COL<0) COL=0;
                       p[POS]=COL+50;
            }
            else p[POS]=0;
            POS++;
        }
    }
    _dosmemputl(p, 16000, 0xa0000);
    }
}

int inicio()
{
    memset(&regs, 0, sizeof regs);
    regs.x.ax=0x13;
    __dpmi_int(0x10, &regs);
    outportb (0x3c8, 0);
    for (N=0; N<=127; N++)
    {
        outportb (0x3c9, 0);
        outportb (0x3c9, (int)N/4);
        outportb (0x3c9, (int)N/2);
    }
    for (N=0; N<=127; N++)
    {
        outportb (0x3c9, (int)N/2);
        outportb (0x3c9, (int)31+N/4);
        outportb (0x3c9, 63);
    }
    return(0);
}
